//
// ImageAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class ImageAPI {
    /**

     - parameter attachment: (form)  (optional)
     - parameter fileName: (form)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiImageUploadImageMultiPartFormPost(attachment: String? = nil, fileName: String? = nil, completion: @escaping ((_ data: ImageResponseModelArrayResponseModel?,_ error: Error?) -> Void)) {
        apiImageUploadImageMultiPartFormPostWithRequestBuilder(attachment: attachment, fileName: fileName).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     - POST /api/Image/UploadImageMultiPartForm
     - 

     - examples: [{contentType=application/json, example={
  "Data" : [ {
    "Path" : "Path"
  }, {
    "Path" : "Path"
  } ],
  "ErrorMessage" : "ErrorMessage"
}}]
     - parameter attachment: (form)  (optional)
     - parameter fileName: (form)  (optional)

     - returns: RequestBuilder<ImageResponseModelArrayResponseModel> 
     */
    open class func apiImageUploadImageMultiPartFormPostWithRequestBuilder(attachment: String? = nil, fileName: String? = nil) -> RequestBuilder<ImageResponseModelArrayResponseModel> {
        let path = "/api/Image/UploadImageMultiPartForm"
        let URLString = SwaggerClientAPI.basePath + path
        let formParams: [String:Any?] = [
                "Attachment": attachment,
                "FileName": fileName
        ]

        let nonNullParameters = APIHelper.rejectNil(formParams)
        let parameters = APIHelper.convertBoolToString(nonNullParameters)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<ImageResponseModelArrayResponseModel>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**

     - parameter body: (body)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiImageUploadImagePost(body: ImageRequestModel? = nil, completion: @escaping ((_ data: ImageResponseModelArrayResponseModel?,_ error: Error?) -> Void)) {
        apiImageUploadImagePostWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     - POST /api/Image/UploadImage
     - 

     - examples: [{contentType=application/json, example={
  "Data" : [ {
    "Path" : "Path"
  }, {
    "Path" : "Path"
  } ],
  "ErrorMessage" : "ErrorMessage"
}}]
     - parameter body: (body)  (optional)

     - returns: RequestBuilder<ImageResponseModelArrayResponseModel> 
     */
    open class func apiImageUploadImagePostWithRequestBuilder(body: ImageRequestModel? = nil) -> RequestBuilder<ImageResponseModelArrayResponseModel> {
        let path = "/api/Image/UploadImage"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<ImageResponseModelArrayResponseModel>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**

     - parameter body: (body)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiImageUploadImageWithByteArrayPost(body: ImageBinaryRequest? = nil, completion: @escaping ((_ data: ImageResponseModelArrayResponseModel?,_ error: Error?) -> Void)) {
        apiImageUploadImageWithByteArrayPostWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     - POST /api/Image/UploadImageWithByteArray
     - 

     - examples: [{contentType=application/json, example={
  "Data" : [ {
    "Path" : "Path"
  }, {
    "Path" : "Path"
  } ],
  "ErrorMessage" : "ErrorMessage"
}}]
     - parameter body: (body)  (optional)

     - returns: RequestBuilder<ImageResponseModelArrayResponseModel> 
     */
    open class func apiImageUploadImageWithByteArrayPostWithRequestBuilder(body: ImageBinaryRequest? = nil) -> RequestBuilder<ImageResponseModelArrayResponseModel> {
        let path = "/api/Image/UploadImageWithByteArray"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<ImageResponseModelArrayResponseModel>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
